import pygame
from pygame.locals import *

from pykitten.data import load_image
from pykitten import utils
from pykitten.gui import TextLine

from resources import JB
from basestate import BaseState, FadeState, SuperSpecialFadeState


class YouWin(BaseState):
    def __init__(self):
        BaseState.__init__(self)
        self.img = load_image("story/outro.png")
        self.background.blit(self.img, (0,0))

        self.alpha = 0
        self.the_end = TextLine("The End.", color=(255,255,255),
            bgcolor=(255,181,145), fontsize=16)
        self.the_end.set_alpha(0)
        self.the_end_pos = utils.center(self.the_end.get_size(),
            (800,600))
        self.the_end_pos[1] = 140

        JB.play("beachwaves.ogg", -1)

        self.faded_in = False
        self.faded_out = False
        self.add_kbevent(KEYDOWN, K_ESCAPE, self.do_quit)

    def do_quit(self):
        surf = pygame.Surface((800,600))
        JB.stop()
        surf.fill((0,0,0))
        self.next = SuperSpecialFadeState(self.background, surf, play=1)
        self.quit()

    def update_other(self):
        if self.alpha < 255:
            self.alpha += 0.3
            self.the_end.set_alpha(self.alpha)
            self.background.blit(self.the_end, self.the_end_pos)
            self.screen.blit(self.background, (0,0))
            pygame.display.flip()


    def main_start(self):
        if not self.faded_in:
            self.faded_in = True
            surf = pygame.Surface((800,600))
            surf.fill((0,0,0))
            self.next = SuperSpecialFadeState(surf, self.background, fade=0.1)
            self.pause()
            self.quit()
        else:
            self.screen.blit(self.background, (0,0))
            pygame.display.flip()


class FadeOut(BaseState):
    pass
